Minutes from 5th OpenVDB TSC meeting, Jan. 17, 2019

Attendees: John M., *Jeff* L., *Nick* A., *Ken* M., *Peter* C., *Dan* B., Andrew P.

Additional Attendees: Bruce Chernia (Intel), Daniel Heckenberg (Animal Logic)

Agenda:

1) Confirmation of quorum
2) Selection of secretary
3) Update from TAC (Ken)
4) Update on Multi-Res grid from Autodesk (Ken)
5) Intel representative
6) JIT for OpenVDB (Nic)
7) Copyright notice (Dan)
8) Write permissions (Dan)
9) Release process (Dan)
10) Cleanup and improve repository (Ken)
11) Schedule next meeting

1) A quorum was confirmed.

2) Secretary - Nick Avramoussis.

3) OpenColourIO is accepted within the probationary stage. There's been interest form 3rd party
companies, including Nvidia, Intel and Autodesk.

Security and CI:

The issue of a security expert was discussed as something which should be addressed across all
ASWF projects. Jeff mentioned that the guidelines are vague for this role and that in the context
of VDB, this mainly relates to bug handling/invalid file reading. Ken mentioned the concern of
arbitrary metadata in regards to attacks. Andrew advised on static code analysis tools as part
of a CI build (lgtm, clang). Dan mentioned using clang tidy as a CI step which would be easier
to solve on the CMake side to address CII best practices.

The viability of Travis support was questioned. Previous limitations have been removed (Nov 2018)
which now allow for building on Ubuntu 16.04 for Houdini 17. Dan has a pull request which
optimises the Travis builds to help with timeouts, though it's agreed that it is not a sustainable
solution. It was agreed that the main thing holding us back from a Jenkins transition was the
CMake build.

CMake:

A fully supported CMake build through CI is becoming more of a priority. Current TSC members
do not have extensive experience with CMake. Nick mentioned his experience and usage within
DNEG production and will share example modification. It was agreed that other expertise would
be ideal for deciding on a final structure. OpenColorIO (and others) have extensive CMake
systems which could perhaps be used to help establish CMake conventions within the ASWF. Ken
mentioned a concern if this was actioned due to the amount of dependencies OpenVDB has. Ken
mentioned that WETA have dedicated a lot of time to standardizing CMake builds. Ken will
establish communication with Nick, Kimble and Bruce to start a discussion on CMake structure.

4) Autodesk have received the TSC questions on their MRes grid structure. No concerns have been
raised but they have asked for more time to respond.

5) Bruce Chernia (Intel) spoke on a desire to investigate OpenVDB integration with Embree and
OSPRay. These tools are exclusively focused on real time ray tracing on the CPU. Bruce mentioned
that they would be happy to contribute back findings to the OpenVDB project during their
investigations.

6) Nick spoke on the current state of OpenVDB AX. A stable V1.0.0 release is still planed and
will involve an incorporation into OpenVDB. This release will incorporate all items visible
on the OpenVDB AX roadmap, available within the AX repository on DNEGs github. Nick mentioned
that a summer release is most likely, with an integration to be performed before SIGGRAPH 2019.
Jeff and Nick discussed concerns in regards to Houdini integration, with a commitment being
made to support various VEX syntax.

SIGGRAPH:

Ken brought up the OpenVDB course at SIGGRAPH 2019. Ken will send around an email thread to
start a discussion on topics to be presented.

EMail Lists:

Jon brought up that TSC members should try where possible to use the aswf e-mail lists. Dan
mentioned that the private e-mail list is currently public. Jon to check and confirm a switch
to private.

Contributing File:

A clause in the CONTRIBUTING.md file which currently declares a committer's responsibility as
'25% of one's time' is to be maintained but re-worded. The main desire is to ensure TSC members
can be held accountable if no work is apparent.

7) The OpenVDB copyright notices need to be updated for 2019. A unanimous agreement was made to
switch to a SPDX license. This can be done independently of removing the copyright dates.
Jon recommended to add an additional copyright with the dates removed and not remove the current
DreamWorks one.

8) Ken cannot be added as a reviewer onto current PRs and will check his write access status on
the repository. Currently no TSC members have admin access to the ASWF repo, required for setting
code review and pull request policy. It was agreed that Ken, Peter, Dan and Nick will be given
admin rights. Ken to submit this request to the LF. Dan to send an e-mail to the ASWF helpdesk
regarding JIRA watchers.

9) An official OpenVDB 6 announcement needs to be performed. Peter is the only TSC member with
access to the website. Peter suggested on a vote in the next TSC meeting on whether we continue
binary distributions.

10) ~Time

11) Our next TSC meeting is scheduled for Thursday Jan 24, 2019 11am-12pm PST.
