Minutes from 6th OpenVDB TSC meeting, Jan. 24, 2019

Attendees: John M., *Jeff* L., *Nick* A., *Ken* M., *Peter* C., *Dan* B., Andrew P.

Additional Attendees: Bruce Chernia (Intel), naren vadaplli, Thanh Ha, Greg Gewickey

Agenda:

1) Confirmation of quorum
2) Selection of secretary
3) SIGGRAPH Course proposal (Ken)
4) Update on permissions, release process, jira & code coverage (Dan)
5) Cleanup and improve repository (Ken)
6) Road map (Ken)
7) Schedule next meeting

1) Quorum was confirmed

2) Secretary - Jeff Lait.

3) Siggraph Course

Nick, Dan and Ken confirmed they are interested and likely have topics to
present as a 1.5 hour course submission.

4a) Update on permissions

admin status is restricted to ASWF admin, so will not be granted to TSC.
Dan will submit a help desk ticket to increase minimum reviews to one
from zero.

4b) Release Process

4b1) Website

Website repo is built and functional.  DNS transfer is still on-going, but
may have just been approved.  Doxygen build step is still missing, but
that can be fixed later.

4b2) Release Process documentation

Peter will draft a release document to roughly cover the current release
process.

4b3) Conflicts in Changes file

With the non-linear nature of pull requests, the changes file generates
conflicts.

One approach is to use openstack reno.  Dan will investigate reno, as used in
https://docs.releng.linuxfoundation.org/projects/lftools/en/latest/release-notes.html
as one option.

Another suggestion is to submit changes as separate files that are then merged
after the pull request is approved.

Any automated system should document all the changes since the last
version and preserve links by to DOxygen documentation.


4c) JIRA

Jeff & Ken still have to sign into JIRA.

Ideally we have JIRA & GitHub integration.  Most solutions seem to cost
money.  Thanh will investigate what are practical as this may show
up for other ASWF projects.  Ken will raise this in the next ASWF TAC meeting.

4d) Continuous Integration Update

Cmake transition is unclear.  It seems other projects are waiting on
our decisions, so we may need to move first to cmake.  Pushing to Jenkins
may be a way to trigger a push to Cmake.

Currently in process of increasing warning level in CI to match that at
DreamWorks so CI compliant checkins don't fail at DWA.

Interest in adding the Intel Compiler to CI; but the licensing implications
have to be determined.

4e) Code Coverage

There is a unit code coverage plugin that we need approval for.
Unanimous consent for installing CodeCov plugin (https://codecov.io/)

We also have interest in some form of tab/whitespace validation.
The DCO test has probot that seems to be able to handle these.  However,
pre-commit was suggested as another option.  It can also hook into
git-hooks so the enforcment can be done before CI.

5/6) Cleanup and Roadmap

A lot of time is spent on adminstration.  When can we talk about the
actual product?

- Improve build time
  - split up unit tests, avoid trailing tests
- Unit test coverage
- Documentation
- Cook books - completely out of date
- Source tree messy?
  - Headers that define many classes
  - Consolidate methods that do the same thing
- What are we planning on adding?
- Provide tasks

We resolved 20 minutes of next meeting to be devoted to roadmap.

7) The next TSC meeting is scheduled for Thursday Jan 31, 2019, 11am-12pm PST.
