Minutes from 8th OpenVDB TSC meeting, Feb. 14, 2019

Attendees: *Jeff* L., *Nick* A., *Ken* M., *Peter* C., *Dan* B., Andrew P.

Additional Attendees: Bruce Chernia (Intel), Thanh Ha

Agenda:

1) Confirmation of quorum
2) Selection of secretary
3) Update from TAC
4) SIGGRAPH course
5) Jenkins vs Travis
6) Bug Reporting / External PRs
7) Other
8) Schedule next meeting

1) A quorum was confirmed.

2) Secretary - Nick Avramoussis.

3) Ken gave a brief 5 minute overview of the TSC at the TAC meet. The majority
of our time thus far has been spent on process + gave a condensed overview of our
future work (ax, extended points support etc). OpenColorIO has been fully
approved as the second ASWF project. OpenEXR is on track for approval in March
2019.

Apple is now on the TAC, Andrew mentioned to them that they could provide
assistance through build system contributions for their platform for ASWF
projects. There is some concern with the level of emphasis on MacOS and Windows
support as they have not been specified as requirements by the ASWF.

The issue of a security consultant was again raised. Ken mentioned to the TAC
that the OpenVDB TSC have struggled to fill this position. Jim/Bruce at Intel
spoke that they might be able to provide assistance in this area. It's currently
not clear exactly what security issues the TSC needs to be responsible for. Jeff/
Nick gave examples of supported implementation that could be used maliciously.
Andrew: anything we provide from the ASWF should be signed that it's a valid file
in the given format.

4) Ken submitted a proposal for the OpenVDB SIGGRAPH Course on Feb. 12th. The
submission is still open for a 1h 30min time slot and has room for potentially
one more presentation. The first topic, presented by Ken, will be an update on
OpenVDB since the last course (4.1->6.1) and content about the new governance.
Nick will present OpenVDB AX, Dan's content may include delay loading and point
advection. There may be an opportunity to discuss the Autodesk's mres grid,
depending on their reply (still pending).

5) Dan: three points in favor of Travis/Circle/Github CI. The first is that the
current Jenkins setup uses an additional repository for the CI build system,
where as Travis uses the CI included in the OpenVDB repository. This is a
limitation of the way that Jenkins is currently configured in the ASWF. Having
the CI in the same repo makes it easier to sync, jump around the history, merge,
fork etc. Thanh mentioned that there is a way that Jenkins might be setup to
accommodate this, but it uses Jenkins's own proprietary systems. Second, the
logs in Travis have a much nicer layout to Jenkins. Third, Travis has inbuilt
ccache support. We also already have Travis integration. The additional
computational resources are the main benefit of the current Jenkins system.
Thanh has been investigating Circle CI and another LF group (the LF Networking
group) has been looking at alternatives. This group meets Fridays.

Meeting notes from the Tooling working group:

https://wiki.lfnetworking.org/display/LN/LFN+Infra+Work+Group+1+Feb+19

Meeting schedule/mailing list for the working group for anyone who's interested
in attending:

https://lists.lfnetworking.org/g/TAC/topic/lfn_tooling_subgroup/29576852?p=

Note that CMake support is unrelated to the CI and should be prioritized.

6) Main point of entry for reporting bugs isn't clear. There are four places:
JIRA, Github issues, e-mail, forum. The forum has recently been getting spam.
Membership is required for the forum which Ken has to confirm. We could enable
moderation so that posts have to be approved before they are visible. Jeff
mentioned that SideFX only moderate first posts.

Dan: Github issues are nice as they allow you to close the issue/mark as resolved.
Nick: the lack of documentation exacerbates the problem of potentially trivial
forum posts and dilutes the forum. Nick brought up the current issue with external
(non-TSC) pull requests stagnating. It was agreed that we need a Github check for
CLA. Dan mentioned that it might be worth consolidating the current contributing
.md files to have a clearer documented process for external PRs.

Dan's message on the above: https://lists.aswf.io/g/openvdb-dev/message/41

7) Jeff used the current statistics header in OpenVDB to introduce VDB reduction
support (for volumes, not points) in Houdini 17.5. Nick asked if the hscript
expression might also benefit from supporting VDBs.

Peter mentioned that the process functions in Houdini which operate on set types
of VDB grids could be changed to take a tuple of types to allow for cleaner
instantiation of supported grid types across Houdini SOPs.

TAC meeting discussed versioning. All projects should be using the same type of
versioning. Semantic versioning was the common thread.

OpenVDB ABI only for grid compatibility. Nick asked if this was written down
anywhere, it doesn't seem to be. Dan mentioned the issue with unsupported file
format warnings causing lots of confusion.

Peter asked about Clarisse render hooks for VDB points. Nick: we tried something
like this in the past but never completed it. Clarisse tools which work on
VDB Points pass around the grids with a final conversion to Clarisse geometry
when rendered.

Dan brought up the removal of deprecation warnings. Dan to write a proposal on
our deprecation policy to vote on at the next TSC meeting.

Jeff: should we remove GU/GR Prim VDB from the repository. Consensus was that as
long as they build, they are good to stay.

Andrew, chat log: is there someone that I can send the CII certification
spreadsheet document to so the TSC can begin to own the completion of the process?
We'll continue to help complete it as we can, but I think ownership of the doc
should transfer to the TSC.

8) The next TSC meeting is TBC. Pending agenda, this will either be on Feb 21st
or Feb 28th, 2019, 11am-12pm PST.
