Minutes from 13th OpenVDB TSC meeting, April 18, 2019

NOTE: This meeting was moved one week later from the originally scheduled
April 11th and one hour later.

Attendees: *Ken* M., *Nick* A., *Dan* B., *Peter* C., *Jeff* L.

Additional Attendees: Bruce Chernia (Intel), John Mertic (LF)

Agenda:

1) Confirmation of quorum
2) Selection of secretary
3) Response from Autodesk
4) 6.1 Release
5) Copyright/SPDX
6) DSO_TAG_INFO
7) OpenVDB Twitter
8) Next Meeting

1) A quorum was confirmed. Ken chaired.

2) Secretary - Jeff Lait

3) Response from Autodesk

Existing mres system doesn't have file io or transform implemented,
which means it has a lot to gain by VDB unification.

The existing mres system doesn't seem to have canonical formats for template
parameters.  We've found with VDB that while fully templatable topology
was useful for prototyping, in the long run it is infeasible to support
multiple options across compilation boundaries - VDB is already notoriously
slow to compile with just type instantiation.  Mres would need to find
ideally one, perhaps two, canonical template instantiations.

Mres has multiple roots so can support all of space rather than only
a single cube.

While Grid/Metadata/Transform/IO may be shared, it seems the Tree is
less likely to be shared.  Having a different structure, however,
justifies integration - if it were truly the same there would be
little point to it.

The TSC was divided on importance of activation.  This is an essential
part of VDB and is widely used outside of just narrow band computations
to do masking and achieve efficiency.  However, activation implies
non-present voxels that complicates a lot of algorithms (like blur)
possibly unnecessarily.  Some were concerned imposing activation may
remove some of the benefits of Mres, such as being defined throughout
space and/or efficiency.

We are still unsure which algorithms are being provided.  A critical
number likely need to be present to justify including it.

We need a clearer understanding of how mres is superior to a stack-of-grids.
Successful multi-res has been implemented in, for example, SP-grids using
stack-of-grids, and VDB seems well suited to a stack-of-grids multi
resolution workflow.  Ideally some non-trivial algorithm (such as maybe
Eikonal equation?) could be shared in the Mres implementation, and we
could attempt to re-implement as a stack-of-vdb grids.  This would give
a good understanding of where Mres is superior and provide some bench
marks of speed differences.

We will start a new email thread to discuss a response and attempt
a conference call when that is ready.  SIGGRAPH is proposed as a potential
meeting time to discuss this directly.

4) 6.1 Release

There is a press release planned for SIGGRAPH for which we want a release.

Nick and Dan believe we are ready for a 6.1 release of primarily CMake
changes in a few weeks.  Pushing 6.1 too long into the future will leave
the SIGGRAPH release hollow, however.   But getting CMake out of the way
would help close a lot of outstanding work.

Nick is hopeful AX may make the SIGGRAPH release timeframe which will
provide significant updates for that release.

Werror PR is mostly done, except outstanding type conversion.  Since
how to handle type conversions is ambiguous and would delay the PR,
instead they should be silenced until a future PR.

Circle CI seems strictly better than Travis and we will switch to Circle
going forward.

Pre-Houdini 16.0 deprecation removes 2.5k LOC so is eagerly awaited.

Unanimous consent on sending an email with planned 6.1 Release Candidate PRs.
TSC members should comment if they have outstanding issues.  If not, will merge
by middle of next week.


5) Copyright/SPDX

Dan will remove the 2018 to 2019 transition.   Peter will seek explicit
permission to remove the year from copyright notices so we can stop
the yearly bump.  SPDX is to be left to later.

6) DSO TAG INFO

It is believed that the DSO_TAG_INFO is unnecessary, so can be removed
from CMake builds to avoid breaking compiler caches.   Jeff requested
verification from production as this has been removed from the 18.0
examples.

7) OpenVDB Twitter

Dan has acquired the openvdb twitter handle and will make it available
to the TSC for our social media needs.

8) Next Meeting

April 25th 2019.  3pm-4pm EDT (GMT-4).

Note it will be at the same time as this meeting (moved one hour later to
account for NZ non-DST)
