Minutes from 33rd OpenVDB TSC meeting, November 21, 2019, (GMT)

Attendees: *Nick* A., *Dan* B., *Jeff* L., *Ken* M.

Additional Attendees: Bruce Chernia (Intel), John Mertic (LF)

Regrets: *Peter* C.

Agenda:

1) Confirm quorum
2) Secretary
3) Summary of last months
4) Release plan for v7
5) Copyright statements from DWA
6) Upcoming PR’s (round robin)
7) Distributed VDB in Houdini: Gas Net VDB Slice Exchange
8) SSE4.2 in Houdini Clarification.
9) PR227 (Additional memory check fixes from Autodesk, requires second approval)
10) Next Meeting

1) Quorum was confirmed.

2) Secretary was Dan Bailey

Preamble)

A representative from Intel planning to come to a future TSC meeting to discuss
VKL. Bruce is considering inviting someone to join from Intel who may be able to
contribute to the project too.

3) Summary of last months

Quick overview of discussion in the last month. Decided that leaf node memory
usage can't be achieved in the ABI=7 window. Clarification of the performance
improvements in using the POPCNT instruction.

It was decided that a release branch will be used in the last few weeks prior to
a release. PRs will continue to be merged into master as normal, however any PRs
intended for the upcoming release will be merged or cherry-picked across to the
release branch. This will allow normal development and merging to continue while
a release is being prepared.

All in favour of introducing an experimental ABI flag so that we can develop and
test planned ABI changes without having to wait until the start of the next
major release which is typically a very short window.

4) Many of the bigger changes will not make it into 7.0 as they're not
ABI-related. This includes Ken's fast sweeping and Dan's point partitioning
work. There are a couple of ABI-related tasks outstanding, in particular Nick
and Dan to discuss OVDB-33.

5) Copyright statements from DWA

Approval from DWA legal on the proposed license change after discussion with the
LF. Jeff Bradley from DWA has submitted a PR which needs an additional approval
to merge. Dan to reach out to Jeff and others at DWA to discuss the copyright
header/footer changes, though it was agreed this shouldn't hold up the license
change.

6) Upcoming PR’s (round robin)

Ken has two major PRs, one more minor one that involves stencil improvements and
gaussian curvature and a larger subsequent one to add the fast sweeping method.
Planned for before the end of the year. Ken also to take on ownership of Peter's
sharpening work which we believe to just be reviewing.

Dan has a number of PRs coming involving point partitioning and VDB Points
merging that will be introduced one-by-one.

Nick intends to look at MeshToVolume. Initial plan is some cleanup, improvements
for C++11/C++14 and documentation. Still an issue with determinism that hasn't
been tracked down.

Dan to look at taking over the POPCNT work to get it finished in time for 7.0.

7) Distributed VDB in Houdini: Gas Net VDB Slice Exchange

Jeff wishes to introduce a Gas Net VDB Distribution Microsolver to the project
based on Houdini distribution. It will be the first DOP node in the VDB project
but that is not expected to be an issue. Also, VDB SOP and VDB Activate SOP
still planned for contribution.

8) SSE4.2 in Houdini Clarification.

Houdini does not currently ship with SSE 4.2 enabled which confirms our decision
to have it be an option is the correct one.

9) PR227 (Additional memory check fixes from Autodesk, requires second approval)

This PR needs an additional approval from a TSC member to be merged. External
PRs require two TSC approvals to merge.

10) Next Meeting

Next planned meeting is:

Novemeber 28th 2019. 2pm-3pm EST (GMT-5).
