Minutes from 40th OpenVDB TSC meeting, February 13th, 2020, (GMT)

Attendees: *Ken* M., *Nick* A., *Dan* B., *Jeff* L.

Additional Attendees: Bruce Chernia (Intel)

Regrets: *Peter* C.

Agenda:

1) Confirm quorum
2) Secretary
3) Summary of annual TAC/ASWF meetings 
4) Mres from Autodesk 
5) Google summer of code - revisited
6) SIGGRAPH
7) Roadmap
8) GitHub Actions / develop branch
9) GPU discussion (unplanned)
10) Quick review of outstanding PRs 
11) Next meeting

1) Quorum was confirmed.

2) Secretary was Dan Bailey

3) Summary of annual TAC/ASWF meetings 

Ken presented an overview of OpenVDB and brief summary of the project activites
over the last year at the annual face-to-face TAC meeting. Not a lot of progress
this last year, main achievement has been CMake. Ken spoke to someone who might
be interested in helping with our CMake build system.

USD is a big focus of the ASWF, new working group being set up. Like us,
developers at Pixar are suffering from support burden from many studios building
the project and asking questions.

Security is still a concern.

4) Mres from Autodesk 

Ken received version from Autodesk, will aim to get it building in preparation
for developing a VDB alternative starting sometime in the next month or so.

5) Google summer of code - revisited

Project proposals made and submitted as part of ASWF application, organizations
announced 20th Feb.

6) SIGGRAPH

Deadline has passed for a Course, however all agreed there should only be a BOF
this year.

7) Roadmap

Putting off until next meeting as Jeff has no mic. Intend for it to be a
dedicated meeting.

8) GitHub Actions / develop branch

The plan is to make the develop branch the default merge target for PRs. All
external contributors will make PRs into the develop branch and once approved,
one of the TSC members will take responsibility for merging into develop, adding
release notes and making any other edits, then making an additional PR from
develop into master. TSC members will predominantly make PRs directly into
master.

This will tie into adopting GitHub Actions as our sole CI and deprecating our
use of Azure. The develop branch will have fewer CI checks to attempt to reduce
the barrier to entry and will only run the Houdini checks if the user has set a
Houdini CLA environment variable. All TSC members will be required to set this
environment variable so that Houdini checks are always run when making PRs into
master.

GitHub Actions will also be used for other automation such as preparing releases
and keeping the develop branch synced up with the master branch.

Dan has a PR into the TAC to list requirements for one TSC member of each
project having admin access. Once permissions have been granted, this migration
can start.

9) GPU discussion (unplanned)

Ken has tried a linear read-only implementation of the grid for the GPU and it
works well. Considering extending to incorporate min/max. Question about making
just the topology read-only and allow value edits, not currently implemented but
should be feasible. Jeff very interested, Ken to share his implementation in the
next few weeks.

Still room to modify tree data structure to make it more amenable to the GPU, in
particular allowing for custom allocators (ABI change). Dan suggested we
dedicate one TSC meeting to focus on the GPU and invite some domain experts.

10) Quick review of outstanding PRs 

PR605 - Ken happy for this to be merged.

PR455 - what to do with the sharpen, Nick suggests we integrate true gaussian
implementation first. Still waiting Ken approval.

PR623 - Jeff to review and give feedback.

PR589 - Nick has verbally approved, awaiting final approval from Ken.

11) Next meeting

February 20th 2020. 2pm-3pm EST (GMT-5).
