Minutes from 44th OpenVDB TSC meeting, April 2nd, 2020, (GMT)

Attendees: *Nick* A., *Dan* B., *Jeff* L., *Ken* M.

Additional Attendees: Bruce Chernia (Intel), Johannes Meng (Intel), JT Nelson (Blender), John Metric (Linux Foundation), Jim Leuper (DW), David Tonnesen (DW), Peter Cheng (DW), Andre Pradhana (DW)

Regrets: *Peter* C.

Agenda:

1) Confirm quorum
2) Secretary
3) Intel VKL
4) Nano VDB
5) Hashing VDB Grids
6) CI Instability
7) Admin rights
8) Google Summer of Code
9) Houdini 18++
10) VDB Activate
11) AX language spec out.
12) Improved Morphology, PR #675
13) ASWF Nexus
14) Fast Sweeping
15) Next meeting

1) Quorum was confirmed.

2) Secretary was Jeff Lait

3) Intel VKL

Tentative plan for a presentation in 3 weeks.  Will announce on the mailing
list when ready.

4) Nano VDB

Presented at the render council.  Linearized tree, not fragmented.  Uses grid
as native BVH.  DDA rewritten for this.  Much faster than current, even on CPU.
1.2 GigaRay/second on dragon. On par with triangle meshes.  In talks to release
it.  Min/max per node.  Active bbox per node.  Some of the DDA could port back
to mainline VDB.

5) Hashing VDB Grids

Is hashing useful?  Need a fast hash function, and a cryptographic hash.
Ideally hash data separate from metadata.  We should provide the architecture
to plug in a hash function that is multithreaded & knows about active voxels,
and how to sequence the node hashes.  This was already brought up on a
previous TSC meeting.

6) CI Instability

Reasons CI is broken:

a) Out of disk space building Houdini dsos.  Sometimes we get extra space so it doesn't fail, but if we get the actual official limits it fails.  Need an auto-deleter as we build dsos.  Maybe remove symobls?  We have a PR to remove the debug build, this should be approved by someone on the TSC.

b) TBB version was broken in vcpackage.  Fixed temporarily until github actions fixes it.

c) On Windows, cpu-timer unit test.  Concern is if the timer is a steady timer.  Or is thread-safe.  Need to double check this.  Unit tests with timers in general are a problem.

Dan will split up the unit test change from the chrono changes and investigate if the new timer is thread safe now.

7) Admin rights

Dan moves he gets admin rights to OpenVDB, contingent on him not turning off CLA checks.  Ken, Nick, Jeff, and Dan vote aye, no one disagrees.  This motion passes.

8) Google Summer of Code

10 proposals, 1 of which passes initial cut.  Student wants to improve delayed loading on windows.  Likely based in India.  We have to choose two mentors.  Likely need Nick for similar timezone.  Talk about in next meeting.  April 20th deadline to decide.

9) Houdini 18++

Next major version of Houdini will have at least VDB 7.0.0.

10) VDB Activate

How much should be changed to make a PR?  Brace correction?

Jeff to do a PR of current version, we will then decide how much
prettying needs to be done to bring it in.

11) AX language spec out.

This is still being written, but the original spec for bikeshedding
can be found here:

https://idclip.github.io/openvdbax-doxygen/ax.html

Nick will send around a set of high level questions that are known issues.

12) Improved Morphology, PR #675

Greatly improves speed of dilating more than 8 voxels.  Google sheet on the PR with some timings. Mostly a change of framework.

13) ASWF Nexus

Only OpenVDB is using it.   Do we really need it?  We have >100 MB files that we can host somewhere.  If we can be given new links, we'll reset the links.  ASWF will move to S3 and give us new links.

All four TSC members at the meeting explicitly approve of this transition.

14) Fast Sweeping

Version at DW has issues, but are improved and fixed in the new one.  Ken has a PR almost ready.

15) Next Meeting:

April 9th 2020. 2pm-3pm EDT (GMT-4).

