Minutes from 53rd OpenVDB TSC meeting, June 25th, 2020, (GMT)

Attendees: *Nick* A., *Jeff* L., *Ken* M., *Dan* B.

Additional Attendees: Brecht Van Lommel, Andre Pradhana (DW)

Regrets: *Peter* C.

Agenda:

1) Confirm quorum
2) Secretary
3) New Meeting Time
4) Forum Posts
5) 7.1/8 Release Schedule
6) VDB Net Slice Exchange
7) Next meeting


1) Quorum was confirmed.

2) Secretary was Dan Bailey

3) New Meeting Time

Dan has requested the TSC meeting be moved to an earlier day of the week.
Consensus that the new time should be on Tuesday and an hour earlier than the
current meeting (5pm GMT) - 10am PDT / 1pm EDT / 6pm BST. Ken to adjust the
calendar invite.

4) Forum Posts

A question was raised about the sharpen feature in the Convert VDB SOP when
converting polygons. This implementation (hvdb::SharpenFeaturesOp) is only
provided in the Houdini toolset and not in the core library itself. Initial
suggestion was for other vendors to copy the implementation in the Houdini
library with an acknowledgement that this implementation should really be pushed
down to the core library. However, it was noted that VDB provides rather
primitive mesh data structures. The best approach would probably be to wrap the
Houdini API and to adapt the implementation to work based on a templated wrapper
class, but needs more investigation to understand how easy that may be to
achieve in practice. At the very least a unit test based on the implementation
in the Houdini plugin would be more useful to other DCCs and allow us to offer
basic regression testing.

A generic mesh data structure in Houdini could be useful. Ken also keen on a
tetrahedral data structure, converting VDBs to tets would be useful. Jeff
mentioned that dumb tet conversion is trivial, robust tet conversion that works
well with finite element simulation is much harder, but would be very desirable.

5) 7.1/8 Release Schedule

Aim is to release VDB 7.1 as soon as possible so that Jeff can base the next
Houdini release on this version, ideally by 1st July. Likely will be until a
week or two after this date. Jeff suggests that a 7.2 release should come before
8.0 and include AX so that DCCs do not need to wait on the VFX Reference
Platform bumping to the next major version. 8.0 is scheduled for Q4.

* VDB Sharpen SOP

Ken to look at and approve the VDB Sharpen SOP. Still needs a unit test, but Ken
may approve without for sake of expediency.

* Fast Sweeping / VDB Extrapolate SOP

Andre to look at creating a draft PR with the DWA version of the Extrapolate SOP
adapted to the Ken's implementation. Work can be done on refining the SOP UI
parameters in parallel with finishing the API.

* VDB Merge SOP

Dan to look at finishing a first version of the VDB Merge SOP. It will be
limited in functionality (add fog volumes, union SDFs) and can be extended in
future releases. Question about usability if reordering of inputs changes
resolution as proposed with first input being used as resolution only.

Nick raised concerns about having two SOPs doing the same thing (VDB Combine SOP
vs VDB Merge SOP). Adapting the Combine SOP is feasible however would not be as
efficient as a multi-input SOP for stealing use cases. The multi-input is also
more intuitive for many common workflows and would not require changing modes as
often - the default mode in the VDB Combine SOP is Copy A which is almost never
what is needed.

General feeling that the VDB Combine SOP is a bit of a kitchen sink and could do
with some improvements. The Combine SOP is still useful because it is intuitive
in certain cases such as subtracting one VDB from another. Open question about
what to do with the Combine SOP in the future, but decision is to proceed with
introducing VDB Merge SOP for now and allow artists to opt-in gradually.

* VDB Net Slice Exchange

Andre has compiled and tested the VDB Net Slice Exchange that SideFX provides as
part of the HDK toolkit samples, however has not been able to test it on
production examples yet. Waiting on a little more production testing before
including it in a VDB release.

6) Next Meeting

New day, new time. Tuesday June 30th, 2020. 1pm-2pm EDT (GMT-4).
